Proxmox/install/plex-install.sh

139 lines
3.9 KiB
Bash
Raw Normal View History

2022-04-25 17:18:35 +02:00
#!/usr/bin/env bash
2022-12-22 21:04:51 +01:00
if [ "$VERBOSE" == "yes" ]; then set -x; fi
2022-10-30 02:04:45 +01:00
YW=$(echo "\033[33m")
RD=$(echo "\033[01;31m")
BL=$(echo "\033[36m")
GN=$(echo "\033[1;92m")
CL=$(echo "\033[m")
2022-04-19 00:11:49 +02:00
RETRY_NUM=10
RETRY_EVERY=3
NUM=$RETRY_NUM
CM="${GN}${CL}"
CROSS="${RD}${CL}"
BFR="\\r\\033[K"
HOLD="-"
2022-04-25 17:18:35 +02:00
set -o errexit
set -o errtrace
set -o nounset
set -o pipefail
shopt -s expand_aliases
alias die='EXIT=$? LINE=$LINENO error_exit'
trap die ERR
function error_exit() {
trap - ERR
Correct Spelling (#360) * Update adguard-install.sh * Update daemonsync-install.sh * Update dashy-install.sh * Update debian-install.sh * Update deconz-install.sh * Update docker-install.sh * Update esphome-install.sh * Update grafana-install.sh * Update heimdalldashboard-install.sh * Update homeassistant-install.sh * Update homebridge-install.sh * Update influxdb-install.sh * Update iobroker-install.sh * Update jellyfin-install.sh * Update keycloak-install.sh * Update magicmirror-install.sh * Update mariadb-install.sh * Update meshcentral-install.sh * Update motioneye-install.sh * Update mqtt-install.sh * Update nginx-proxy-manager-install.sh * Update nocodb-install.sh * Update node-red-install.sh * Update omada-install.sh * Update openhab-install.sh * Update photoprism-install.sh * Update pihole-install.sh * Update plex-install.sh * Update podman-homeassistant-install.sh * Update postgresql-install.sh * Update prometheus-install.sh * Update technitiumdns-install.sh * Update ubuntu-install.sh * Update unifi-install.sh * Update uptimekuma-install.sh * Update vaultwarden-install.sh * Update whoogle-install.sh * Update wireguard-install.sh * Update zigbee2mqtt-install.sh * Update zwavejs2mqtt-install.sh * Update adguard-v3.sh * Update create_lxc.sh * Update daemonsync-v3.sh * Update dashy-v3.sh * Update debian-v3.sh * Update deconz-v3.sh * Update docker-v3.sh * Update esphome-v3.sh * Update grafana-v3.sh * Update heimdalldashboard-v3.sh * Update homeassistant-v3.sh * Update homebridge-v3.sh * Update influxdb-v3.sh * Update iobroker-v3.sh * Update jellyfin-v3.sh * Update keycloak-v3.sh * Update magicmirror-v3.sh * Update mariadb-v3.sh * Update meshcentral-v3.sh * Update motioneye-v3.sh * Update mqtt-v3.sh * Update nginx-proxy-manager-v3.sh * Update nocodb-v3.sh * Update node-red-v3.sh * Update omada-v3.sh * Update openhab-v3.sh * Update photoprism-v3.sh * Update pihole-v3.sh * Update plex-v3.sh * Update podman-homeassistant-v3.sh * Update postgresql-v3.sh * Update prometheus-v3.sh * Update technitiumdns-v3.sh * Update ubuntu-v3.sh * Update unifi-v3.sh * Update uptimekuma-v3.sh * Update vaultwarden-v3.sh * Update whoogle-v3.sh * Update wireguard-v3.sh * Update zigbee2mqtt-v3.sh * Update zwavejs2mqtt-v3.sh
2022-07-20 12:10:39 +02:00
local reason="Unknown failure occurred."
2022-04-25 17:18:35 +02:00
local msg="${1:-$reason}"
local flag="${RD}‼ ERROR ${CL}$EXIT@$LINE"
echo -e "$flag $msg" 1>&2
exit $EXIT
}
2022-04-19 00:11:49 +02:00
function msg_info() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -ne " ${HOLD} ${YW}${msg}..."
2022-04-19 00:11:49 +02:00
}
function msg_ok() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CM} ${GN}${msg}${CL}"
2022-04-19 00:11:49 +02:00
}
2022-08-31 11:20:58 +02:00
function msg_error() {
2022-10-30 02:04:45 +01:00
local msg="$1"
echo -e "${BFR} ${CROSS} ${RD}${msg}${CL}"
2022-08-31 11:20:58 +02:00
}
2022-04-19 00:11:49 +02:00
msg_info "Setting up Container OS "
sed -i "/$LANG/ s/\(^# \)//" /etc/locale.gen
locale-gen >/dev/null
while [ "$(hostname -I)" = "" ]; do
2022-10-30 02:04:45 +01:00
echo 1>&2 -en "${CROSS}${RD} No Network! "
2022-04-19 00:11:49 +02:00
sleep $RETRY_EVERY
((NUM--))
2022-10-30 02:04:45 +01:00
if [ $NUM -eq 0 ]; then
echo 1>&2 -e "${CROSS}${RD} No Network After $RETRY_NUM Tries${CL}"
2022-04-19 00:11:49 +02:00
exit 1
fi
done
msg_ok "Set up Container OS"
msg_ok "Network Connected: ${BL}$(hostname -I)"
2022-10-22 11:52:33 +02:00
set +e
alias die=''
2022-10-30 02:04:45 +01:00
if nc -zw1 8.8.8.8 443; then msg_ok "Internet Connected"; else
msg_error "Internet NOT Connected"
read -r -p "Would you like to continue anyway? <y/N> " prompt
if [[ $prompt == "y" || $prompt == "Y" || $prompt == "yes" || $prompt == "Yes" ]]; then
echo -e " ⚠️ ${RD}Expect Issues Without Internet${CL}"
else
echo -e " 🖧 Check Network Settings"
exit 1
fi
2022-10-30 02:04:45 +01:00
fi
2022-08-31 11:20:58 +02:00
RESOLVEDIP=$(nslookup "github.com" | awk -F':' '/^Address: / { matched = 1 } matched { print $2}' | xargs)
2022-10-30 02:04:45 +01:00
if [[ -z "$RESOLVEDIP" ]]; then msg_error "DNS Lookup Failure"; else msg_ok "DNS Resolved github.com to $RESOLVEDIP"; fi
2022-10-22 11:52:33 +02:00
alias die='EXIT=$? LINE=$LINENO error_exit'
set -e
2022-08-31 11:20:58 +02:00
2022-04-19 00:11:49 +02:00
msg_info "Updating Container OS"
2022-08-30 00:43:55 +02:00
apt-get update &>/dev/null
apt-get -y upgrade &>/dev/null
2022-04-19 00:11:49 +02:00
msg_ok "Updated Container OS"
msg_info "Installing Dependencies"
apt-get install -y curl &>/dev/null
apt-get install -y sudo &>/dev/null
apt-get install -y gnupg &>/dev/null
msg_ok "Installed Dependencies"
if [[ -z "$(grep -w "100000" /proc/self/uid_map)" ]]; then
2022-10-30 02:04:45 +01:00
msg_info "Setting Up Hardware Acceleration"
apt-get -y install \
2022-04-19 00:11:49 +02:00
va-driver-all \
ocl-icd-libopencl1 \
beignet-opencl-icd &>/dev/null
2022-10-30 02:04:45 +01:00
/bin/chgrp video /dev/dri
/bin/chmod 755 /dev/dri
/bin/chmod 660 /dev/dri/*
msg_ok "Set Up Hardware Acceleration"
fi
2022-04-19 00:11:49 +02:00
msg_info "Setting Up Plex Media Server Repository"
wget -q https://downloads.plex.tv/plex-keys/PlexSign.key -O - | sudo apt-key add - &>/dev/null
2022-10-30 02:04:45 +01:00
echo "deb [arch=$(dpkg --print-architecture)] https://downloads.plex.tv/repo/deb/ public main" | tee /etc/apt/sources.list.d/plexmediaserver.list &>/dev/null
2022-04-19 00:11:49 +02:00
msg_ok "Set Up Plex Media Server Repository"
msg_info "Installing Plex Media Server"
apt-get update &>/dev/null
apt-get -o Dpkg::Options::="--force-confold" install -y plexmediaserver &>/dev/null
msg_ok "Installed Plex Media Server"
2022-10-30 02:04:45 +01:00
PASS=$(grep -w "root" /etc/shadow | cut -b6)
2023-01-23 16:42:50 +01:00
echo "export TERM='xterm-256color'" >>/root/.bashrc
2022-10-30 02:04:45 +01:00
if [[ $PASS != $ ]]; then
msg_info "Customizing Container"
chmod -x /etc/update-motd.d/*
touch ~/.hushlogin
GETTY_OVERRIDE="/etc/systemd/system/container-getty@1.service.d/override.conf"
mkdir -p $(dirname $GETTY_OVERRIDE)
cat <<EOF >$GETTY_OVERRIDE
2022-04-19 00:11:49 +02:00
[Service]
ExecStart=
ExecStart=-/sbin/agetty --autologin root --noclear --keep-baud tty%I 115200,38400,9600 \$TERM
EOF
2022-10-30 02:04:45 +01:00
systemctl daemon-reload
systemctl restart $(basename $(dirname $GETTY_OVERRIDE) | sed 's/\.d//')
msg_ok "Customized Container"
fi
if [[ "${SSH_ROOT}" == "yes" ]]; then
2022-12-19 17:08:29 +01:00
sed -i "s/#PermitRootLogin prohibit-password/PermitRootLogin yes/g" /etc/ssh/sshd_config
systemctl restart sshd
fi
2022-10-30 02:04:45 +01:00
2022-04-19 00:11:49 +02:00
msg_info "Cleaning up"
apt-get autoremove >/dev/null
apt-get autoclean >/dev/null
msg_ok "Cleaned"